// Code generated by mockery v2.20.0. DO NOT EDIT.

package mocks

import (
	context "context"

	component "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-plugin-sdk/internal-shared/component"

	hcl "github.com/hashicorp/hcl/v2"

	mock "github.com/stretchr/testify/mock"
)

// PipelinePlugin is an autogenerated mock type for the PipelinePlugin type
type PipelinePlugin struct {
	mock.Mock
}

// ActionInput provides a mock function with given fields: ctx, actionName
func (_m *PipelinePlugin) ActionInput(ctx context.Context, actionName string) (interface{}, error) {
	ret := _m.Called(ctx, actionName)

	var r0 interface{}
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (interface{}, error)); ok {
		return rf(ctx, actionName)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) interface{}); ok {
		r0 = rf(ctx, actionName)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, actionName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ActionOutput provides a mock function with given fields: ctx, actionName
func (_m *PipelinePlugin) ActionOutput(ctx context.Context, actionName string) (interface{}, error) {
	ret := _m.Called(ctx, actionName)

	var r0 interface{}
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (interface{}, error)); ok {
		return rf(ctx, actionName)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) interface{}); ok {
		r0 = rf(ctx, actionName)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, actionName)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Config provides a mock function with given fields: ctx
func (_m *PipelinePlugin) Config(ctx context.Context) (interface{}, error) {
	ret := _m.Called(ctx)

	var r0 interface{}
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context) (interface{}, error)); ok {
		return rf(ctx)
	}
	if rf, ok := ret.Get(0).(func(context.Context) interface{}); ok {
		r0 = rf(ctx)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// ConfigSet provides a mock function with given fields: ctx, config
func (_m *PipelinePlugin) ConfigSet(ctx context.Context, config interface{}) error {
	ret := _m.Called(ctx, config)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, interface{}) error); ok {
		r0 = rf(ctx, config)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// ExecuteAction provides a mock function with given fields: ctx, input, evalCtx
func (_m *PipelinePlugin) ExecuteAction(ctx context.Context, input *component.PipelinePluginActionInput, evalCtx *hcl.EvalContext) interface{} {
	ret := _m.Called(ctx, input, evalCtx)

	var r0 interface{}
	if rf, ok := ret.Get(0).(func(context.Context, *component.PipelinePluginActionInput, *hcl.EvalContext) interface{}); ok {
		r0 = rf(ctx, input, evalCtx)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(interface{})
		}
	}

	return r0
}

// Schema provides a mock function with given fields: ctx
func (_m *PipelinePlugin) Schema(ctx context.Context) (*component.PipelinePluginSchema, error) {
	ret := _m.Called(ctx)

	var r0 *component.PipelinePluginSchema
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context) (*component.PipelinePluginSchema, error)); ok {
		return rf(ctx)
	}
	if rf, ok := ret.Get(0).(func(context.Context) *component.PipelinePluginSchema); ok {
		r0 = rf(ctx)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*component.PipelinePluginSchema)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context) error); ok {
		r1 = rf(ctx)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Shutdown provides a mock function with given fields: ctx
func (_m *PipelinePlugin) Shutdown(ctx context.Context) error {
	ret := _m.Called(ctx)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context) error); ok {
		r0 = rf(ctx)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewPipelinePlugin interface {
	mock.TestingT
	Cleanup(func())
}

// NewPipelinePlugin creates a new instance of PipelinePlugin. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewPipelinePlugin(t mockConstructorTestingTNewPipelinePlugin) *PipelinePlugin {
	mock := &PipelinePlugin{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
